@echo off

REM Check if environment properly setup
CALL INIT.BAT
IF "%ERROR_INSTALL%" == "1" GOTO end

if not exist "%BACKUP_DIR%" goto post_action
FOR %%F in ("%INSTALLED_PATH%"\*) DO if not exist "%BACKUP_DIR%\%%~nF%%~xF" echo unable to restore "%%~nF%%~xF"

IF NOT EXIST "%INSTALL_PATH_1%" GOTO path_2
FOR %%F in ("%INSTALLED_PATH%"\*) DO if exist "%BACKUP_DIR%\%%~nF%%~xF"  copy /Y "%BACKUP_DIR%\%%~nF%%~xF" "%INSTALL_PATH_1%"
:path_2
IF NOT EXIST "%INSTALL_PATH_2%" GOTO path_3
FOR %%F in ("%INSTALLED_PATH%"\*) DO if exist "%BACKUP_DIR%\%%~nF%%~xF"  copy /Y "%BACKUP_DIR%\%%~nF%%~xF" "%INSTALL_PATH_2%"
:path_3 
IF NOT EXIST "%INSTALL_PATH_3%" GOTO gac_install
FOR %%F in ("%INSTALLED_PATH%"\*) DO if exist "%BACKUP_DIR%\%%~nF%%~xF"  copy /Y "%BACKUP_DIR%\%%~nF%%~xF" "%INSTALL_PATH_3%"

:gac_install
if "%GAC_NOT_FOUND%" == "1" GOTO post_action
REM Check if the files installed are in the GAC
FOR %%F in ("%INSTALLED_PATH%"\*) DO if exist "%BACKUP_DIR%\%%~nF%%~xF"  CALL :GAC_UNINSTALL "%BACKUP_DIR%\%%~nF%%~xF"

:post_action
echo restoration completed...
GOTO END
:end
GOTO :EOF

REM Function to install a file in the GAC if present 
:gac_uninstall
FOR /F "usebackq" %%c IN (`gacutil -l %~n1 ^| find "= 1" /c`) do set installed=%%c
if "%installed%" == "0" goto :EOF
REM Replace file in the GAC
gacutil /if %1
GOTO :EOF